<?php

namespace Vab\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;
use Folha\Util\Valor;

use Util\DateUtil;
use Util\{
    //FileUploader,
    //HCMParameters,
    Repositories,
    //Util
    NovoCodigo
};

class CalculoValeTransporteRepository {
    /** @var EntityManager */
    protected $entityManager;

    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->entityManager        = $entityManager;
        $this->connection           = $entityManager->getConnection();
    }
    
    public function getParametroValeTransporte($nrorg, $dtmescompecencia){
        $params = array(
            "P_NRORG"          => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompecencia);

$sql = "SELECT
    PARAMVALEH.*
FROM
         VAB_PARAMVALEM PARAMVALEM
    JOIN VAB_PARAMVALEH PARAMVALEH ON PARAMVALEH.NRORG = PARAMVALEM.NRORG
                                      AND PARAMVALEH.NRPARAMVALEM = PARAMVALEM.NRPARAMVALEM
                                      AND PARAMVALEH.DTMESCOMPETENC = (
        SELECT
            MAX(PH.DTMESCOMPETENC)
        FROM
            VAB_PARAMVALEH PH
        WHERE
                PH.NRORG = PARAMVALEH.NRORG
            AND PH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
    )
WHERE
    PARAMVALEM.NRORG = :P_NRORG
ORDER BY PARAMVALEH.DTMESCOMPETENC DESC";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        
        return $retorno;
    }
}
